pcl::IterativeClosestPointWithNormals< PointSource, PointTarget, Scalar > Class Template Reference
Module registration

IterativeClosestPointWithNormals is a special case of IterativeClosestPoint, that uses a transformation estimated based on Point to Plane distances by default. More...

`#include <pcl/registration/icp.h>`

Inheritance diagram for pcl::IterativeClosestPointWithNormals< PointSource, PointTarget, Scalar >:

## Public Types

typedef IterativeClosestPoint< PointSource, PointTarget, Scalar >::PointCloudSource | PointCloudSource
typedef IterativeClosestPoint< PointSource, PointTarget, Scalar >::PointCloudTarget | PointCloudTarget
typedef IterativeClosestPoint< PointSource, PointTarget, Scalar >::Matrix4 | Matrix4
typedef boost::shared_ptr< IterativeClosestPoint< PointSource, PointTarget, Scalar > > | Ptr
typedef boost::shared_ptr< const IterativeClosestPoint< PointSource, PointTarget, Scalar > > | ConstPtr
Public Types inherited from pcl::IterativeClosestPoint< PointSource, PointTarget, Scalar >
typedef Registration< PointSource, PointTarget, Scalar >::PointCloudSource | PointCloudSource
typedef PointCloudSource::Ptr | PointCloudSourcePtr
typedef PointCloudSource::ConstPtr | PointCloudSourceConstPtr
typedef Registration< PointSource, PointTarget, Scalar >::PointCloudTarget | PointCloudTarget
typedef PointCloudTarget::Ptr | PointCloudTargetPtr
typedef PointCloudTarget::ConstPtr | PointCloudTargetConstPtr
typedef PointIndices::Ptr | PointIndicesPtr
typedef PointIndices::ConstPtr | PointIndicesConstPtr
typedef boost::shared_ptr< IterativeClosestPoint< PointSource, PointTarget, Scalar > > | Ptr
typedef boost::shared_ptr< const IterativeClosestPoint< PointSource, PointTarget, Scalar > > | ConstPtr
typedef Registration< PointSource, PointTarget, Scalar >::Matrix4 | Matrix4
Public Types inherited from pcl::Registration< PointSource, PointTarget, Scalar >
typedef Eigen::Matrix< Scalar, 4, 4 > | Matrix4
typedef boost::shared_ptr< Registration< PointSource, PointTarget, Scalar > > | Ptr
typedef boost::shared_ptr< const Registration< PointSource, PointTarget, Scalar > > | ConstPtr
typedef pcl::registration::CorrespondenceRejector::Ptr | CorrespondenceRejectorPtr
typedef pcl::search::KdTree< PointTarget > | KdTree
typedef pcl::search::KdTree< PointTarget >::Ptr | KdTreePtr
typedef pcl::search::KdTree< PointSource > | KdTreeReciprocal
typedef KdTree::Ptr | KdTreeReciprocalPtr
typedef pcl::PointCloud< PointSource > | PointCloudSource
typedef PointCloudSource::Ptr | PointCloudSourcePtr
typedef PointCloudSource::ConstPtr | PointCloudSourceConstPtr
typedef pcl::PointCloud< PointTarget > | PointCloudTarget
typedef PointCloudTarget::Ptr | PointCloudTargetPtr
typedef PointCloudTarget::ConstPtr | PointCloudTargetConstPtr
typedef KdTree::PointRepresentationConstPtr | PointRepresentationConstPtr
typedef pcl::registration::TransformationEstimation< PointSource, PointTarget, Scalar > | TransformationEstimation
typedef TransformationEstimation::Ptr | TransformationEstimationPtr
typedef TransformationEstimation::ConstPtr | TransformationEstimationConstPtr
typedef pcl::registration::CorrespondenceEstimationBase< PointSource, PointTarget, Scalar > | CorrespondenceEstimation
typedef CorrespondenceEstimation::Ptr | CorrespondenceEstimationPtr
typedef CorrespondenceEstimation::ConstPtr | CorrespondenceEstimationConstPtr
Public Types inherited from pcl::PCLBase< PointSource >
typedef pcl::PointCloud< PointSource > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| IterativeClosestPointWithNormals ()
| Empty constructor. More...
virtual | ~IterativeClosestPointWithNormals ()
| Empty destructor. More...
Public Member Functions inherited from pcl::IterativeClosestPoint< PointSource, PointTarget, Scalar >
| IterativeClosestPoint ()
| Empty constructor. More...
virtual | ~IterativeClosestPoint ()
| Empty destructor. More...
pcl::registration::DefaultConvergenceCriteria< Scalar >::Ptr | getConvergeCriteria ()
| Returns a pointer to the DefaultConvergenceCriteria used by the IterativeClosestPoint class. More...
virtual void | setInputSource (const PointCloudSourceConstPtr &cloud)
| Provide a pointer to the input source (e.g., the point cloud that we want to align to the target) More...
virtual void | setInputTarget (const PointCloudTargetConstPtr &cloud)
| Provide a pointer to the input target (e.g., the point cloud that we want to align to the target) More...
void | setUseReciprocalCorrespondences (bool use_reciprocal_correspondence)
| Set whether to use reciprocal correspondence or not. More...
bool | getUseReciprocalCorrespondences () const
| Obtain whether reciprocal correspondence are used or not. More...
Public Member Functions inherited from pcl::Registration< PointSource, PointTarget, Scalar >
| Registration ()
| Empty constructor. More...
virtual | ~Registration ()
| destructor. More...
void | setTransformationEstimation (const TransformationEstimationPtr &te)
| Provide a pointer to the transformation estimation object. More...
void | setCorrespondenceEstimation (const CorrespondenceEstimationPtr &ce)
| Provide a pointer to the correspondence estimation object. More...
void | setInputCloud (const PointCloudSourceConstPtr &cloud)
| Provide a pointer to the input source (e.g., the point cloud that we want to align to the target) More...
PointCloudSourceConstPtr const | getInputCloud ()
| Get a pointer to the input point cloud dataset target. More...
virtual void | setInputSource (const PointCloudSourceConstPtr &cloud)
| Provide a pointer to the input source (e.g., the point cloud that we want to align to the target) More...
PointCloudSourceConstPtr const | getInputSource ()
| Get a pointer to the input point cloud dataset target. More...
virtual void | setInputTarget (const PointCloudTargetConstPtr &cloud)
| Provide a pointer to the input target (e.g., the point cloud that we want to align the input source to) More...
PointCloudTargetConstPtr const | getInputTarget ()
| Get a pointer to the input point cloud dataset target. More...
void | setSearchMethodTarget (const KdTreePtr &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the target cloud. More...
KdTreePtr | getSearchMethodTarget () const
| Get a pointer to the search method used to find correspondences in the target cloud. More...
void | setSearchMethodSource (const KdTreeReciprocalPtr &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the source cloud (usually used by reciprocal correspondence finding). More...
KdTreeReciprocalPtr | getSearchMethodSource () const
| Get a pointer to the search method used to find correspondences in the source cloud. More...
Matrix4 | getFinalTransformation ()
| Get the final transformation matrix estimated by the registration method. More...
Matrix4 | getLastIncrementalTransformation ()
| Get the last incremental transformation matrix estimated by the registration method. More...
void | setMaximumIterations (int nr_iterations)
| Set the maximum number of iterations the internal optimization should run for. More...
int | getMaximumIterations ()
| Get the maximum number of iterations the internal optimization should run for, as set by the user. More...
void | setRANSACIterations (int ransac_iterations)
| Set the number of iterations RANSAC should run for. More...
double | getRANSACIterations ()
| Get the number of iterations RANSAC should run for, as set by the user. More...
void | setRANSACOutlierRejectionThreshold (double inlier_threshold)
| Set the inlier distance threshold for the internal RANSAC outlier rejection loop. More...
double | getRANSACOutlierRejectionThreshold ()
| Get the inlier distance threshold for the internal outlier rejection loop as set by the user. More...
void | setMaxCorrespondenceDistance (double distance_threshold)
| Set the maximum distance threshold between two correspondent points in source <-> target. More...
double | getMaxCorrespondenceDistance ()
| Get the maximum distance threshold between two correspondent points in source <-> target. More...
void | setTransformationEpsilon (double epsilon)
| Set the transformation epsilon (maximum allowable difference between two consecutive transformations) in order for an optimization to be considered as having converged to the final solution. More...
double | getTransformationEpsilon ()
| Get the transformation epsilon (maximum allowable difference between two consecutive transformations) as set by the user. More...
void | setEuclideanFitnessEpsilon (double epsilon)
| Set the maximum allowed Euclidean error between two consecutive steps in the ICP loop, before the algorithm is considered to have converged. More...
double | getEuclideanFitnessEpsilon ()
| Get the maximum allowed distance error before the algorithm will be considered to have converged, as set by the user. More...
void | setPointRepresentation (const PointRepresentationConstPtr &point_representation)
| Provide a boost shared pointer to the PointRepresentation to be used when comparing points. More...
template<typename FunctionSignature >
bool | registerVisualizationCallback (boost::function< FunctionSignature > &visualizerCallback)
| Register the user callback function which will be called from registration thread in order to update point cloud obtained after each iteration. More...
double | getFitnessScore (double max_range=std::numeric_limits< double >::max())
| Obtain the Euclidean fitness score (e.g., sum of squared distances from the source to the target) More...
double | getFitnessScore (const std::vector< float > &distances_a, const std::vector< float > &distances_b)
| Obtain the Euclidean fitness score (e.g., sum of squared distances from the source to the target) from two sets of correspondence distances (distances between source and target points) More...
bool | hasConverged ()
| Return the state of convergence after the last align run. More...
void | align (PointCloudSource &output)
| Call the registration algorithm which estimates the transformation and returns the transformed source (input) as output. More...
void | align (PointCloudSource &output, const Matrix4 &guess)
| Call the registration algorithm which estimates the transformation and returns the transformed source (input) as output. More...
const std::string & | getClassName () const
| Abstract class get name method. More...
bool | initCompute ()
| Internal computation initalization. More...
bool | initComputeReciprocal ()
| Internal computation when reciprocal lookup is needed. More...
void | addCorrespondenceRejector (const CorrespondenceRejectorPtr &rejector)
| Add a new correspondence rejector to the list. More...
std::vector< CorrespondenceRejectorPtr > | getCorrespondenceRejectors ()
| Get the list of correspondence rejectors. More...
bool | removeCorrespondenceRejector (unsigned int i)
| Remove the i-th correspondence rejector in the list. More...
void | clearCorrespondenceRejectors ()
| Clear the list of correspondence rejectors. More...
Public Member Functions inherited from pcl::PCLBase< PointSource >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointSource & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

virtual void | transformCloud (const PointCloudSource &input, PointCloudSource &output, const Matrix4 &transform)
| Apply a rigid transform to a given dataset. More...
Protected Member Functions inherited from pcl::IterativeClosestPoint< PointSource, PointTarget, Scalar >
virtual void | computeTransformation (PointCloudSource &output, const Matrix4 &guess)
| Rigid transformation computation method with initial guess. More...
virtual void | determineRequiredBlobData ()
| Looks at the Estimators and Rejectors and determines whether their blob-setter methods need to be called. More...
Protected Member Functions inherited from pcl::Registration< PointSource, PointTarget, Scalar >
bool | searchForNeighbors (const PointCloudSource &cloud, int index, std::vector< int > &indices, std::vector< float > &distances)
| Search for the closest nearest neighbor of a given point. More...
virtual void | computeTransformation (PointCloudSource &output, const Matrix4 &guess)=0
| Abstract transformation computation method with initial guess. More...
Protected Member Functions inherited from pcl::PCLBase< PointSource >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Public Attributes inherited from pcl::IterativeClosestPoint< PointSource, PointTarget, Scalar >
pcl::registration::DefaultConvergenceCriteria< Scalar >::Ptr | convergence_criteria_
Protected Attributes inherited from pcl::IterativeClosestPoint< PointSource, PointTarget, Scalar >
size_t | x_idx_offset_
| XYZ fields offset. More...
size_t | y_idx_offset_
size_t | z_idx_offset_
size_t | nx_idx_offset_
| Normal fields offset. More...
size_t | ny_idx_offset_
size_t | nz_idx_offset_
bool | use_reciprocal_correspondence_
| The correspondence type used for correspondence estimation. More...
bool | source_has_normals_
| Internal check whether source dataset has normals or not. More...
bool | target_has_normals_
| Internal check whether target dataset has normals or not. More...
bool | need_source_blob_
| Checks for whether estimators and rejectors need various data. More...
bool | need_target_blob_
Protected Attributes inherited from pcl::Registration< PointSource, PointTarget, Scalar >
std::string | reg_name_
| The registration method name. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
KdTreeReciprocalPtr | tree_reciprocal_
| A pointer to the spatial search object of the source. More...
int | nr_iterations_
| The number of iterations the internal optimization ran for (used internally). More...
int | max_iterations_
| The maximum number of iterations the internal optimization should run for. More...
int | ransac_iterations_
| The number of iterations RANSAC should run for. More...
PointCloudTargetConstPtr | target_
| The input point cloud dataset target. More...
Matrix4 | final_transformation_
| The final transformation matrix estimated by the registration method after N iterations. More...
Matrix4 | transformation_
| The transformation matrix estimated by the registration method. More...
Matrix4 | previous_transformation_
| The previous transformation matrix estimated by the registration method (used internally). More...
double | transformation_epsilon_
| The maximum difference between two consecutive transformations in order to consider convergence (user defined). More...
double | euclidean_fitness_epsilon_
| The maximum allowed Euclidean error between two consecutive steps in the ICP loop, before the algorithm is considered to have converged. More...
double | corr_dist_threshold_
| The maximum distance threshold between two correspondent points in source <-> target. More...
double | inlier_threshold_
| The inlier distance threshold for the internal RANSAC outlier rejection loop. More...
bool | converged_
| Holds internal convergence state, given user parameters. More...
int | min_number_correspondences_
| The minimum number of correspondences that the algorithm needs before attempting to estimate the transformation. More...
CorrespondencesPtr | correspondences_
| The set of correspondences determined at this ICP step. More...
TransformationEstimationPtr | transformation_estimation_
| A TransformationEstimation object, used to calculate the 4x4 rigid transformation. More...
CorrespondenceEstimationPtr | correspondence_estimation_
| A CorrespondenceEstimation object, used to estimate correspondences between the source and the target cloud. More...
std::vector< CorrespondenceRejectorPtr > | correspondence_rejectors_
| The list of correspondence rejectors to use. More...
bool | target_cloud_updated_
| Variable that stores whether we have a new target cloud, meaning we need to pre-process it again. More...
bool | source_cloud_updated_
| Variable that stores whether we have a new source cloud, meaning we need to pre-process it again. More...
bool | force_no_recompute_
| A flag which, if set, means the tree operating on the target cloud will never be recomputed. More...
bool | force_no_recompute_reciprocal_
| A flag which, if set, means the tree operating on the source cloud will never be recomputed. More...
boost::function< void(const pcl::PointCloud< PointSource > &cloud_src, const std::vector< int > &indices_src, const pcl::PointCloud< PointTarget > &cloud_tgt, const std::vector< int > &indices_tgt)> | update_visualizer_
| Callback function to update intermediate source point cloud position during it's registration to the target point cloud. More...
Protected Attributes inherited from pcl::PCLBase< PointSource >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointSource, typename PointTarget, typename Scalar = float>
class pcl::IterativeClosestPointWithNormals< PointSource, PointTarget, Scalar >

IterativeClosestPointWithNormals is a special case of IterativeClosestPoint, that uses a transformation estimated based on Point to Plane distances by default.

Author
  Radu B. Rusu

Definition at line 297 of file icp.h.

## Member Typedef Documentation

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef boost::shared_ptr<const IterativeClosestPoint<PointSource, PointTarget, Scalar> > pcl::IterativeClosestPointWithNormals< PointSource, PointTarget, Scalar >::ConstPtr

Definition at line 309 of file icp.h.

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef IterativeClosestPoint<PointSource, PointTarget, Scalar>::Matrix4 pcl::IterativeClosestPointWithNormals< PointSource, PointTarget, Scalar >::Matrix4

Definition at line 302 of file icp.h.

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef IterativeClosestPoint<PointSource, PointTarget, Scalar>::PointCloudSource pcl::IterativeClosestPointWithNormals< PointSource, PointTarget, Scalar >::PointCloudSource

Definition at line 300 of file icp.h.

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef IterativeClosestPoint<PointSource, PointTarget, Scalar>::PointCloudTarget pcl::IterativeClosestPointWithNormals< PointSource, PointTarget, Scalar >::PointCloudTarget

Definition at line 301 of file icp.h.

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef boost::shared_ptr<IterativeClosestPoint<PointSource, PointTarget, Scalar> > pcl::IterativeClosestPointWithNormals< PointSource, PointTarget, Scalar >::Ptr

Definition at line 308 of file icp.h.

## Constructor & Destructor Documentation

template<typename PointSource , typename PointTarget , typename Scalar = float>

pcl::IterativeClosestPointWithNormals< PointSource, PointTarget, Scalar >::IterativeClosestPointWithNormals | ( |  | ) |

inline

Empty constructor.

Definition at line 312 of file icp.h.

References pcl::Registration< PointSource, PointTarget, Scalar >::reg_name_, and pcl::Registration< PointSource, PointTarget, Scalar >::transformation_estimation_.

template<typename PointSource , typename PointTarget , typename Scalar = float>

virtual pcl::IterativeClosestPointWithNormals< PointSource, PointTarget, Scalar >::~IterativeClosestPointWithNormals | ( |  | ) |

inline virtual

Empty destructor.

Definition at line 320 of file icp.h.

References pcl::IterativeClosestPoint< PointSource, PointTarget, Scalar >::transformCloud().

## Member Function Documentation

template<typename PointSource , typename PointTarget , typename Scalar >

void pcl::IterativeClosestPointWithNormals< PointSource, PointTarget, Scalar >::transformCloud | ( | const PointCloudSource & | input,
|  | PointCloudSource & | output,
|  | const Matrix4 & | transform
| ) |  |

protected virtual

Apply a rigid transform to a given dataset.

Parameters

  [in] | input | the input point cloud
  [out] | output | the resultant output point cloud
  [in] | transform | a 4x4 rigid transformation

Note
  Can be used with cloud_in equal to cloud_out

Reimplemented from pcl::IterativeClosestPoint< PointSource, PointTarget, Scalar >.

Definition at line 288 of file icp.hpp.

References pcl::transformPointCloudWithNormals().

The documentation for this class was generated from the following files:

- /build/pcl-0nnAvv/pcl-1.7.2/registration/include/pcl/registration/icp.h
- /build/pcl-0nnAvv/pcl-1.7.2/registration/include/pcl/registration/impl/icp.hpp